package de.uebungstool.uebungstool.scheduling.strategies;

import static de.uebungstool.uebungstool.scheduling.threads.SchedulingDiagramConstants.STRATEGIES_RR;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import de.uebungstool.uebungstool.scheduling.logic.SchedulingService;
import de.uebungstool.uebungstool.scheduling.threads.SchedulingDiagram;
import de.uebungstool.uebungstool.scheduling.threads.SchedulingKernelLevelThread;
import de.uebungstool.uebungstool.scheduling.threads.SchedulingUserLevelThread;
import java.util.Arrays;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

class RRUserlevelStrategyDynamicPrioPreemptive {
  /**
   * configuration String can be created with the client: 1. create a Configuration 2. Fill in the
   * diagram 3. Click generate 'ConfigurationString'
   *
   * <p>All values in the status field will be used to create a user input for both diagrams and it
   * will also be used as the correction values in the expected Diagram
   *
   * <p>Also save the configuration String in order to restore the configuration in browser
   */
  private SchedulingDiagram inputDiagram;

  private SchedulingDiagram expectedDiagram;

  SchedulingService schedulerService = new SchedulingService();

  /**
   * Initialises the Diagram Object with a valid RR Strategy configuration This is the same standard
   * configuration which is used in the Website.
   */
  @BeforeEach
  public void initDiagrams() {
    expectedDiagram = initDiagram();
    inputDiagram = initDiagram();
  }

  /**
   * Creates one Diagram with the standard configuration for this strategy
   *
   * @return new diagram
   */
  private SchedulingDiagram initDiagram() {
    SchedulingDiagram diagram = new SchedulingDiagram();
    diagram.setStrategy(STRATEGIES_RR);
    diagram.setPreemptive(false);
    diagram.setSchedulerTime(true);
    diagram.setDispatcherTime(false);
    diagram.setTimeSliceLength(5);
    diagram.setCoreNumber(1);
    diagram.setInitialScheduler(false);
    return diagram;
  }

  private boolean testConfiguration(String obj, String objKernel) throws JsonProcessingException {
    ObjectMapper objectMapper = new ObjectMapper();
    inputDiagram.userLevelThreads = objectMapper.readValue(obj, SchedulingUserLevelThread[].class);
    inputDiagram.setKernelLevelThreads(
        objectMapper.readValue(objKernel, SchedulingKernelLevelThread[].class));
    expectedDiagram.userLevelThreads =
        initThreadsExpectedDiagram(objectMapper.readValue(obj, SchedulingUserLevelThread[].class));

    schedulerService.evaluate(inputDiagram);
    return inputDiagram.equalCorrection(expectedDiagram);
  }

  private SchedulingUserLevelThread[] initThreadsExpectedDiagram(
      SchedulingUserLevelThread[] readValue) {
    for (SchedulingUserLevelThread u : readValue) {
      Arrays.stream(u.getCells()).forEach(c -> c.setCorrected(c.getStatus()));
    }
    return readValue;
  }

  /**
   * Basic RR configuration with three threads and only the scheduler time
   *
   * <p>Configuration:
   * {"strategy":"RR","schedulerTime":true,"dispatcherTime":true,"userSchedulerTime":true,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":6,"computingTime":6,"id":1000,"name":"P1_U0","startTimePrevious":6,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":19,"deadlineBackup":-1},{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":6,"computingTime":2,"id":1001,"name":"P1_U1","startTimePrevious":6,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":7,"deadlineBackup":-1},{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":0,"computingTime":6,"id":1002,"name":"P1_U2","startTimePrevious":0,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":7,"deadlineBackup":-1},{"parentid":2,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":6,"computingTime":8,"id":2000,"name":"P2_U0","startTimePrevious":6,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":14,"deadlineBackup":-1},{"parentid":2,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":2,"computingTime":7,"id":2001,"name":"P2_U1","startTimePrevious":2,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":6,"deadlineBackup":-1},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Scheduler","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":10,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":1003,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":true},{"startTime":2,"userID":2002,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":true},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false}],"nextID":3,"highestStartingTime":6,"advancedConfigurationOptions":false,"showHelpGuides":true}
   */
  @Test
  void RR_fiveKernel_dispatcher_edgdecaseSamePriority() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setDispatcherTime(true);
    // add threads to the diagram
    String obj =
        "[{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":6,\"id\":1000,\"priority\":19},{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":2,\"id\":1001,\"priority\":7},{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":6,\"id\":1002,\"priority\":7},{\"parentid\":2,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":8,\"id\":2000,\"priority\":14},{\"parentid\":2,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":7,\"id\":2001,\"priority\":6},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":10}]"
            + " ";
    String objKernel =
        "[{\"kernelthreadID\":1,\"userStrategy\":"
            + " 6,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":2,\"userStrategy\":"
            + " 6,\"startTime\":2,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":-1,\"userStrategy\":"
            + " 0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }

  /**
   * Basic RR configuration with three threads, the scheduler time First thread can compute for the
   * complete time, both other threads will be scheduled in the timeslot before their deadline.
   *
   * <p>Configuration:
   * {"strategy":"RR","schedulerTime":true,"dispatcherTime":false,"userSchedulerTime":true,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":3,"ioAftern":-1,"ioLength":-1,"deadline":9,"startTime":2,"computingTime":2,"id":3000,"name":"P3_U0","startTimePrevious":2,"deadlinePrevious":9,"IOInterruptionActivated":false,"priority":16,"deadlineBackup":9},{"parentid":3,"ioAftern":-1,"ioLength":-1,"deadline":6,"startTime":1,"computingTime":3,"id":3001,"name":"P3_U1","startTimePrevious":1,"deadlinePrevious":6,"IOInterruptionActivated":false,"priority":19,"deadlineBackup":6},{"parentid":3,"ioAftern":-1,"ioLength":-1,"deadline":11,"startTime":6,"computingTime":4,"id":3002,"name":"P3_U2","startTimePrevious":6,"deadlinePrevious":11,"IOInterruptionActivated":false,"priority":9,"deadlineBackup":11},{"parentid":4,"ioAftern":-1,"ioLength":-1,"deadline":16,"startTime":8,"computingTime":7,"id":4000,"name":"P4_U0","startTimePrevious":8,"deadlinePrevious":16,"IOInterruptionActivated":false,"priority":7,"deadlineBackup":16},{"parentid":4,"ioAftern":-1,"ioLength":-1,"deadline":10,"startTime":1,"computingTime":7,"id":4001,"name":"P4_U1","startTimePrevious":1,"deadlinePrevious":10,"IOInterruptionActivated":false,"priority":5,"deadlineBackup":10},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Scheduler","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":10,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":1,"userID":3003,"kernelThreadName":"P3","kernelthreadID":3,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":true},{"startTime":1,"userID":4002,"kernelThreadName":"P4","kernelthreadID":4,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":true},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false}],"nextID":5,"highestStartingTime":8,"advancedConfigurationOptions":true,"showHelpGuides":true}
   */
  @Test
  void RR_fiveKernel_deadline() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.

    // add threads to the diagram
    String obj =
        " [{\"parentid\":3,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":9,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":2,\"id\":3000,\"priority\":16},{\"parentid\":3,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":6,\"cells\":[{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":1,\"computingTime\":3,\"id\":3001,\"priority\":19},{\"parentid\":3,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":11,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":4,\"id\":3002,\"priority\":9},{\"parentid\":4,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":16,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":8,\"computingTime\":7,\"id\":4000,\"priority\":7},{\"parentid\":4,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":10,\"cells\":[{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":1,\"computingTime\":7,\"id\":4001,\"priority\":5},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":10}]"
            + " ";
    String objKernel =
        " [{\"kernelthreadID\":3,\"userStrategy\":6,\"startTime\":1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":4,\"userStrategy\":6,\"startTime\":1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":-1,\"userStrategy\":0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }

  /**
   * only one timeslot between the the starttime and the deadline for each thread
   *
   * <p>Configuration:
   * {"strategy":"RR","schedulerTime":true,"dispatcherTime":false,"userSchedulerTime":true,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":5,"startTime":4,"computingTime":8,"id":1000,"name":"P1_U0","startTimePrevious":4,"deadlinePrevious":5,"IOInterruptionActivated":false,"priority":11,"deadlineBackup":19},{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":6,"startTime":5,"computingTime":5,"id":1001,"name":"P1_U1","startTimePrevious":5,"deadlinePrevious":6,"IOInterruptionActivated":false,"priority":12,"deadlineBackup":19},{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":3,"startTime":2,"computingTime":2,"id":1002,"name":"P1_U2","startTimePrevious":2,"deadlinePrevious":3,"IOInterruptionActivated":false,"priority":16,"deadlineBackup":12},{"parentid":2,"ioAftern":1,"ioLength":1,"deadline":6,"startTime":5,"computingTime":2,"id":2000,"name":"P2_U0","startTimePrevious":5,"deadlinePrevious":6,"IOInterruptionActivated":true,"priority":3,"deadlineBackup":7},{"parentid":2,"ioAftern":1,"ioLength":1,"deadline":3,"startTime":2,"computingTime":2,"id":2001,"name":"P2_U1","startTimePrevious":2,"deadlinePrevious":3,"IOInterruptionActivated":true,"priority":14,"deadlineBackup":13},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Scheduler","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":7,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":2,"userID":1003,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-0.6,"prioChangeWaitingKernel":1.4,"userSchedulingPreemptive":false},{"startTime":2,"userID":2002,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-2,"prioChangeWaitingKernel":3,"userSchedulingPreemptive":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false}],"nextID":3,"highestStartingTime":5,"advancedConfigurationOptions":true,"showHelpGuides":true}
   */
  @Test
  void RR_fiveKernel_smallestDeadlineOption() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.

    // add threads to the diagram
    String obj =
        "[{\"parentid\":1,\"ioAftern\":1,\"ioLength\":3,\"deadline\":7,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":3,\"id\":1000,\"priority\":15},{\"parentid\":1,\"ioAftern\":1,\"ioLength\":1,\"deadline\":7,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":2,\"id\":1001,\"priority\":9},{\"parentid\":1,\"ioAftern\":1,\"ioLength\":4,\"deadline\":1,\"cells\":[{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":4,\"id\":1002,\"priority\":7},{\"parentid\":2,\"ioAftern\":2,\"ioLength\":4,\"deadline\":7,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":3,\"id\":2000,\"priority\":14},{\"parentid\":2,\"ioAftern\":2,\"ioLength\":1,\"deadline\":3,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":3,\"id\":2001,\"priority\":6},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":10}]"
            + " ";
    String objKernel =
        "[{\"kernelthreadID\":1,\"userStrategy\":"
            + " 6,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":2,\"userStrategy\":"
            + " 6,\"startTime\":2,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":-1,\"userStrategy\":"
            + " 0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }

  /**
   * Basic RR configuration with three threads, the scheduler time and IO-Interruptions on every
   * thread Contains edge cases for the clockorder and an ioiterruption after the timeslice length
   *
   * <p>Configuration:
   * {"strategy":"RR","schedulerTime":true,"dispatcherTime":true,"userSchedulerTime":true,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":1,"ioLength":3,"deadline":-1,"startTime":6,"computingTime":3,"id":1000,"name":"P1_U0","startTimePrevious":6,"deadlinePrevious":-1,"IOInterruptionActivated":true,"priority":15,"deadlineBackup":-1},{"parentid":1,"ioAftern":1,"ioLength":1,"deadline":-1,"startTime":6,"computingTime":2,"id":1001,"name":"P1_U1","startTimePrevious":6,"deadlinePrevious":-1,"IOInterruptionActivated":true,"priority":9,"deadlineBackup":-1},{"parentid":1,"ioAftern":1,"ioLength":4,"deadline":-1,"startTime":0,"computingTime":4,"id":1002,"name":"P1_U2","startTimePrevious":0,"deadlinePrevious":-1,"IOInterruptionActivated":true,"priority":7,"deadlineBackup":-1},{"parentid":2,"ioAftern":2,"ioLength":4,"deadline":-1,"startTime":6,"computingTime":3,"id":2000,"name":"P2_U0","startTimePrevious":6,"deadlinePrevious":-1,"IOInterruptionActivated":true,"priority":14,"deadlineBackup":-1},{"parentid":2,"ioAftern":2,"ioLength":1,"deadline":-1,"startTime":2,"computingTime":3,"id":2001,"name":"P2_U1","startTimePrevious":2,"deadlinePrevious":-1,"IOInterruptionActivated":true,"priority":6,"deadlineBackup":-1},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Scheduler","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":10,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":1003,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":true},{"startTime":2,"userID":2002,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":true},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false}],"nextID":3,"highestStartingTime":6,"advancedConfigurationOptions":true,"showHelpGuides":true}
   */
  @Test
  void RR_threeKernel_IO() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setDispatcherTime(true);

    // add threads to the diagram
    String obj =
        " [{\"parentid\":1,\"ioAftern\":1,\"ioLength\":3,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":3,\"id\":1000,\"priority\":15},{\"parentid\":1,\"ioAftern\":1,\"ioLength\":1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":2,\"id\":1001,\"priority\":9},{\"parentid\":1,\"ioAftern\":1,\"ioLength\":4,\"deadline\":-1,\"cells\":[{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":4,\"id\":1002,\"priority\":7},{\"parentid\":2,\"ioAftern\":2,\"ioLength\":4,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":3,\"id\":2000,\"priority\":14},{\"parentid\":2,\"ioAftern\":2,\"ioLength\":1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":3,\"id\":2001,\"priority\":6},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":10}]"
            + " ";
    String objKernel =
        " [{\"kernelthreadID\":1,\"userStrategy\":6,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":2,\"userStrategy\":6,\"startTime\":2,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":-1,\"userStrategy\":0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false}]"
            + "  ";
    assert (testConfiguration(obj, objKernel));
  }

  /**
   * Basic RR configuration with three threads, the scheduler time and a deadline at the beginning
   * of the io for every thread. Additionally P2 will be scheduled right before its deadline -< two
   * scheduling timeslots in a row.
   *
   * <p>Configuration:
   * {"strategy":"RR","schedulerTime":true,"dispatcherTime":true,"userSchedulerTime":true,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":1,"ioLength":3,"deadline":16,"startTime":6,"computingTime":3,"id":1000,"name":"P1_U0","startTimePrevious":6,"deadlinePrevious":16,"IOInterruptionActivated":true,"priority":15,"deadlineBackup":16},{"parentid":1,"ioAftern":1,"ioLength":1,"deadline":9,"startTime":6,"computingTime":2,"id":1001,"name":"P1_U1","startTimePrevious":6,"deadlinePrevious":9,"IOInterruptionActivated":true,"priority":9,"deadlineBackup":9},{"parentid":1,"ioAftern":1,"ioLength":4,"deadline":5,"startTime":0,"computingTime":4,"id":1002,"name":"P1_U2","startTimePrevious":0,"deadlinePrevious":5,"IOInterruptionActivated":true,"priority":7,"deadlineBackup":7},{"parentid":2,"ioAftern":2,"ioLength":4,"deadline":15,"startTime":6,"computingTime":3,"id":2000,"name":"P2_U0","startTimePrevious":6,"deadlinePrevious":15,"IOInterruptionActivated":true,"priority":14,"deadlineBackup":15},{"parentid":2,"ioAftern":2,"ioLength":1,"deadline":6,"startTime":2,"computingTime":3,"id":2001,"name":"P2_U1","startTimePrevious":2,"deadlinePrevious":6,"IOInterruptionActivated":true,"priority":6,"deadlineBackup":10},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Scheduler","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":10,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":1003,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":true},{"startTime":2,"userID":2002,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":"Priority","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":true},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false}],"nextID":3,"highestStartingTime":6,"advancedConfigurationOptions":true,"showHelpGuides":true}
   */
  @Test
  void RR_fiveKernel_IODeadline_ioAfterTimeSliceEdgeCase() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setDispatcherTime(true);
    // add threads to the diagram
    String obj =
        "[{\"parentid\":1,\"ioAftern\":1,\"ioLength\":3,\"deadline\":16,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":3,\"id\":1000,\"priority\":15},{\"parentid\":1,\"ioAftern\":1,\"ioLength\":1,\"deadline\":9,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":2,\"id\":1001,\"priority\":9},{\"parentid\":1,\"ioAftern\":1,\"ioLength\":4,\"deadline\":5,\"cells\":[{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":4,\"id\":1002,\"priority\":7},{\"parentid\":2,\"ioAftern\":2,\"ioLength\":4,\"deadline\":15,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":3,\"id\":2000,\"priority\":14},{\"parentid\":2,\"ioAftern\":2,\"ioLength\":1,\"deadline\":6,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":3,\"id\":2001,\"priority\":6},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":10}]"
            + " ";
    String objKernel =
        "[{\"kernelthreadID\":1,\"userStrategy\":"
            + " 6,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":2,\"userStrategy\":"
            + " 6,\"startTime\":2,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":true},{\"kernelthreadID\":-1,\"userStrategy\":"
            + " 0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }
}
